/*****************************************************************************
*                                                                            *
*   Home Finance Database System.                                            *
*   Keep track of your money and have easy access to finding data.           *
*                                                                            *
*   Originally developed on Linux                                            *
*                                                                            *
*   Author: Peter Leif Rasmussen, 1996                                       *
*****************************************************************************/

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<time.h>
#include<unistd.h>
#include"finance.h"

extern int check_descr(char *,opt_unit *);
extern void print_options(opt_unit *);
extern void new_data(opt_unit *);
extern void edit_data(opt_unit *);
extern int changed;

int main_menu();
void print_menu(void);
int exit_check(void);
void load_data(opt_unit *);
void save_data(opt_unit *);
void options(opt_unit *);
void time_check(struct tm *tid);

rec_unit *finance, *finance_end, *temporary;
int item=0;

int main_menu()
{
int choice=0;
char temp[1000];

print_menu();
fgets(temp,1000,stdin);
if(strlen(temp)==1) choice=0;
else choice=atoi(temp);

return(choice);
}

void print_menu(void)
{
printf("\nChoose from the following menu:\n");
printf("1) Enter New Records\n");
printf("2) Load Records From Disk\n");
printf("3) Save Records To Disk\n");
printf("4) Search & Display Records\n");
printf("5) Edit Records\n");
printf("6) Show Options\n");
printf("7) Quit\n");
}

void load_data(opt_unit *check_list)
{
int dummy,previous;
FILE *fp;
rec_unit *temp_point;
char temp[100], answer[100],db_file_read[100];
char dirbuf[100];
char *empty;

if(!(empty=(char *)calloc(100,1))) 
	{
	fprintf(stderr,"Couldn't allocate 100B, please use default file-name\n");
	return;
	}

printf("Is it OK to load data from \"%s\" ?  (y/n) : ",check_list->db_file);
fflush(stdout);
fgets(temp,100,stdin);

if(strlen(temp)==1 || temp[0]=='y') strcpy(db_file_read,check_list->db_file);
else	{
	do{
	  printf("File to read from (? to see normal or + to see long listing): ");
	  fflush(stdout);
	  fgets(answer,100,stdin);
	  strncpy(temp,empty,99);
	  strncpy(temp,answer,strlen(answer)-1);
	  strcat(temp,"\0");
	  if(temp[0]=='?') 
		system("ls -a");
	  else if(temp[0]=='+')
		system("ls -la | more");
	  else strcpy(db_file_read,temp);
	  } while(temp[0]=='?' || temp[0]=='+');
	}

if(!(fp=fopen(db_file_read,"r"))) 
	{
	getcwd(dirbuf,100);
	strcpy(temp,dirbuf);
	strcat(temp,"/");
	strcat(temp,db_file_read);
	printf("The file \"%s\" doesn't exist!\n",temp);
	printf("Please check the files in \"%s\" :\n\n",dirbuf);
	system("ls -a");
	printf("\nPress <Enter> to continue.");fflush(stdout);
	gets(temp);
	return;
	}

if(item==0)
   {
   if(!(temp_point=(rec_unit *)malloc(sizeof(rec_unit)))) 
        {fprintf(stderr,"Couldn't allocate space for finance\n");return;}
   finance=temp_point;
   }
else temp_point=finance_end;

previous=item;

fscanf(fp,"%d",&temp_point->year);

while(temp_point->year!=99999)
  {
  fscanf(fp,"%d",&temp_point->month);
  fscanf(fp,"%d",&temp_point->day);
  fscanf(fp,"%d",&temp_point->descr_length);
  temp_point->description=(char *)malloc(temp_point->descr_length);
  if(temp_point->description==NULL) {fprintf(stderr,"description malloc error\n");return;}
  dummy=fgetc(fp);
  fgets(temp_point->description,temp_point->descr_length,fp);
  fscanf(fp,"%f",&temp_point->income);
  fscanf(fp,"%f",&temp_point->cash);
  fscanf(fp,"%f",&temp_point->credit);
  temp_point->ID=item;

  if(!(temp_point->next_rec=(rec_unit *)malloc(sizeof(rec_unit))))
     {fprintf(stderr,"next_rec malloc error\n");return;}
  temp_point=(rec_unit *)temp_point->next_rec;

  item++;

  fscanf(fp,"%d",&temp_point->year);
  } 

fclose(fp);
finance_end=temp_point;
finance_end->next_rec=(rec_unit *)malloc(sizeof(rec_unit));

printf("%d records were loaded.\n",item-previous);
printf("The database now contains %d records.\n",item);
}

void save_data(opt_unit *check_list)
{
int n=0;
FILE *fp;
rec_unit *temp_point;
char answer[1000];
char *empty;

if(item==0) {printf("There are no records yet!\n");return;}

if(!(empty=(char *)calloc(100,1))) 
	{
	fprintf(stderr,"Couldn't allocate 100B, please use default file-name\n");
	return;
	}

temp_point=finance;

printf("Is it OK to save database to \"%s\" ? (y/n): ",check_list->db_file); 
fflush(stdout);
fgets(answer,1000,stdin);

if(answer[0]=='n') 
	{
	printf("Please type the file name to use: ");fflush(stdout);
	fgets(answer,100,stdin);
	strncpy(check_list->db_file,empty,99);
	strncpy(check_list->db_file,answer,strlen(answer)-1);
	strcat(check_list->db_file,"\0");
	}

if((fp=fopen(check_list->db_file,"r")))
  {fclose(fp);
   printf("The file \"%s\" already exist. Overwrite? (y/n): ",check_list->db_file); 
   fflush(stdout);
   fgets(answer,1000,stdin);
   if(answer[0]=='y' || strlen(answer)==1) fp=fopen(check_list->db_file,"w");
   else { printf("Enter New Data File-Name: ");
          fgets(answer,100,stdin);
	  strncpy(check_list->db_file,empty,99);
	  strncpy(check_list->db_file,answer,strlen(answer)-1);
	  strcat(check_list->db_file,"\0");
          if((fp=fopen(check_list->db_file,"r"))) 
             {
              printf("The file \"%s\" already exist!! Overwrite? (y/n)\n",check_list->db_file);
	      fgets(answer,1000,stdin);
              if(answer[0]=='y' || strlen(answer)==1) 
		fp=fopen(check_list->db_file,"w");
              else return;
             }
          else fp=fopen(check_list->db_file,"w");
         }
  }
else if(!(fp=fopen(check_list->db_file,"w"))) 
       {fprintf(stderr,"fopen error attempting to open \"%s\"\n",
        check_list->db_file);return;}

for(n=0;n<item;n++)
  {
  fprintf(fp,"%d\n",temp_point->year);
  fprintf(fp,"%d\n",temp_point->month);
  fprintf(fp,"%d\n",temp_point->day);
  fprintf(fp,"%d\n",temp_point->descr_length);
  fprintf(fp,"%s\n",temp_point->description);
  fprintf(fp,"%f\n",temp_point->income);
  fprintf(fp,"%f\n",temp_point->cash);
  fprintf(fp,"%f\n",temp_point->credit);
  temp_point=(rec_unit *)temp_point->next_rec;
  } 
fprintf(fp,"%d\n",99999); /** put an endflag in the database **/
fclose(fp);
printf("%d records were saved in the file \"%s\"\n",item,check_list->db_file);
changed=0;
}

void options(opt_unit *check_list)
{
printf("The options presently look like this:\n");
printf("Database File:  %s\n",check_list->db_file);
printf("Options File:  %s\n",check_list->options_file);
printf("Descriptions File:  %s\n",check_list->items_file);
printf("# of descriptions:  %d\n",check_list->items);
}

int exit_check()
{
char answer[100];

if(changed!=0)
	{
	printf("The database has changed!\nDo you want to save it first? (y/n) ");
	fgets(answer,100,stdin);
	if(answer[0]=='y' || strlen(answer)==1) return 1;
	}
return 0;
}


void time_check(struct tm *tid)
{
time_t time_since_1970;
time_since_1970=time((time_t)NULL);
*tid=*localtime(&time_since_1970);
tid->tm_year+=1900;
}
